// JunoOR, 9 de Octubre 2013. Colaboracion en el proyecto Waves, en la partida de Juno hacia Júpiter
//
//
// Adaptacion del programa Balizino para JunoOR, por EB1HBK, basado en el motor CW de Bill Brown WB8ELK
//
// Septiembre de 2013
//
//
//-----------------------------------------------------------------------------------------------------------
//-- Esperamos que esta sencilla aplicación pueda resultarle util. Un saludo cordial de todo el equipo de: --
//-------------------------------------- www.cacharreo.es ---------------------------------------------------
//
//
//
//---Pinout placa Arduino:
//
//  dpin 13: CW Key
//  dpin 12: PTT
//  dpin 3: TX test...........interrumpe programa y se pone TX ON en tanto se ponga este pin a masa
//
//
//***********************************************************************************************************
//******************** CONFIGURACION DE LA IDENTIFICACIÓN DE LA BALIZA BALIZINO *****************************
//***********************************************************************************************************
// al especificar la longitud de las cadenas hay que incluir espacio para el caracter "nulo" de fin de cadena
// NOTA******** Las cadenas "callsign" y "locator" deben configurarse con el distintivo y ubicación adecuados
// dejando ademas un espacio en blanco al final ANTES DE CARGAR EL PROGRAMA EN EL ARDUINO *******************
//***********************************************************************************************************


char callsign[8] = {'E','A','1','R','K','O',' '}; // SUSTITUIR LOS NUMEROS POR EL DISTINTIVO CORRESPONDIENTE*
char locator[8] = {'I','N','6','2','C','H',' '};  // SUSTITUIR LAS LETRAS POR EL LOCATOR CORRESPONDIENTE*****


//************************************************************************************************************
//******* CONFIGURACION DE LA DURACION DEL INTERVALO ENTRE TRASNMISIONES PARA COMPLETAR CICLOS 10 MIN.********
//************************************************************************************************************

int intervalo=7700;  //intervalo de espera hasta completar 30 sg de CW ID(todos estos tiempos en milisegundos)


int retardo1=29875;
int retardo2=30000;

//************************************************************************************************************
//*********************** CONFIGURACION DE LA VELOCIDAD DE TRANSMISION DE CW *********************************
//************************************************************************************************************


// ---------------------------- parametros para telegrafia normal CW ID --------------------------------------

int punto=150;  //duracion del punto en milisegundos, cambiando este parámetro modificamos la velocidad efectiva
                //de transmision del CW (lo normal son 100 msg)


                
int raya=(punto*3); // parametros de CW: raya y espacio, se autoconfiguran en funcion de la duracion
int espacio=(punto);  // que hayamos asignado previamente al punto
int pausa=(raya*2);




//*********************************************************************************************************
//******************************* CONFIGURACION DEL HARDWARE **********************************************
//*********************************************************************************************************


int TXdelay=125;  // tiempo de retardo en milsegundos entre la activacion del PTT y en envio del CW                   


//*********************************************************************************************************
//*** la siguiente configuracion no debiera ser preciso cambiarla, salvo que se modifique el circuito *****
//*********************************************************************************************************

int seta=3;    // en el din 3 se conecta la seta o pulsador de TX continuo para test

int adclen;
byte morse;
byte cwlen;
byte cw;
byte x;
char asciibuf[5];


int cwoutPin = 13; // CW TX output pin, este pin manipula la telegrafia
int ptt = 12; // PTT activa el modo TX para conectar el transmisor


// ********************************************************
// ASCII to Morse Code Lookup Table
// ********************************************************

const unsigned char morse_table[63] = { 	// Morse Code Lookup table

	0b00000001,	//;sp - 0x20 
	0b01001010,	//; ! - 0x21
	0b01101101,	//; " - 0x22
	0b01011110,	//; # - 0x23 // Not available in Morse Code - replace with "-"
	0b10110111,	//; $ - 0x24
	0b01011110,	//; % - 0x25 // Not available in Morse Code - replace with "-"
	0b00111101,	//; & - 0x26
	0b01100001,	//; ' - 0x27
	0b00110010,	//; ( - 0x28
	0b01010010,	//; ) - 0x29
	0b01011110,	//; * - 0x2A // Not available in Morse Code - replace with "-"
	0b00110101,	//; + - 0x2B 
	0b01001100,     //; , - 0x2C
	0b01011110,     //; - - 0x2D
	0b01010101,     //; . - 0x2E
	0b00110110,	//; / - 0x2F
	0b00100000,	//; 0 - 0x30
	0b00100001,	//; 1 - 0x31
	0b00100011,	//; 2 - 0x32
	0b00100111,	//; 3 - 0x33
	0b00101111,	//; 4 - 0x34
	0b00111111,	//; 5 - 0x35
	0b00111110,	//; 6 - 0x36
	0b00111100,	//; 7 - 0x37
	0b00111000,	//; 8 - 0x38
	0b00110000,	//; 9 - 0x39
	0b01111000,	//; : - 0x3A
	0b00101010,	//; ; - 0x3B
	0b00110010,	//; < - 0x3C // send ( since no < in Morse
	0b00101110,	//; = - 0x3D 
	0b01010010,	//; > - 0x3E // send ) since no > in Morse
	0b01110011,	//; ? - 0x3F
	0b01101001,	//; @ - 0x40 
	0b00000101,	//; A - 0x41
	0b00011110,	//; B - 0x42
	0b00011010,	//; C - 0x43
	0b00001110,	//; D - 0x44
	0b00000011,	//; E - 0x45
	0b00011011,	//; F - 0x46
	0b00001100,	//; G - 0x47
	0b00011111,	//; H - 0x48
	0b00000111,	//; I - 0x49
	0b00010001,	//; J - 0x4A
	0b00001010,	//; K - 0x4B
	0b00011101,	//; L - 0x4C
	0b00000100,	//; M - 0x4D
	0b00000110,	//; N - 0x4E
	0b00001000,	//; O - 0x4F
	0b00011001,	//; P - 0x50
	0b00010100,	//; Q - 0x51
	0b00001101,	//; R - 0x52
	0b00001111,	//; S - 0x53
	0b00000010,	//; T - 0x54
	0b00001011,	//; U - 0x55
	0b00010111,	//; V - 0x56
	0b00001001,	//; W - 0x57
	0b00010110,	//; X - 0x58
	0b00010010,	//; Y - 0x59
	0b00011100	//; Z - 0x5A
	
};

// END of Morse Table

void setup(){

pinMode(cwoutPin, OUTPUT);      // sets the digital pin as output 

pinMode(ptt, OUTPUT);
 
 
pinMode(seta, INPUT);

digitalWrite(seta, HIGH);    // activa el pull-up interno del ATmega para el dpin 3 (interrupcion)

attachInterrupt(1,test,LOW);  // poniendo el dpin 3 a masa se transmite constantemente en tanto se mantega  

}


void loop(){
  
                     
         
          
  txon();      // envia HI a la sonda Juno en QRSS
  delay (retardo1);
  txoff();
  delay (retardo2);
  
  
  txon();      // envia HI a la sonda Juno en QRSS
  delay (retardo1);
  txoff();
  delay (retardo2);
  
  
  txon();      // envia HI a la sonda Juno en QRSS
  delay (retardo1);
  txoff();
  delay (retardo2);
  
  
  txon();      // envia HI a la sonda Juno en QRSS
  delay (retardo1);
  txoff();
  delay (retardo2);
  
  
  
  baliza();    // ejecuta la transmision de la baliza, distintivo y locator en CW a velocidad convencional
   
  delay(retardo2);


txon();      // envia HI a la sonda Juno en QRSS
  delay (retardo1);
  txoff();
  delay (retardo2);
  
  txon();      // envia HI a la sonda Juno en QRSS
  delay (retardo1);
  txoff();
  delay (retardo2);
  


  
  baliza();
  
delay(retardo2);
  
  baliza();
  
delay(retardo2);
  
  baliza();
  
delay(retardo2);
 
 }  
  

//------------------------------------------------

// ***********************
// Functions
// ***********************

void sendcw(int cwchar)
{
  
 morse = morse_table[cwchar-0x20];
  
  while(1){

    if(cwchar == ' '){ // if SPACE character then delay 500 mSec between words
      delay(pausa);
      return;
    }
  
    if (morse & 0b00000001){ // compare LSB [ 1=Dit  0=Dah ]
      digitalWrite(cwoutPin, HIGH);
      delay(punto); // (tiempo del punto)
      digitalWrite(cwoutPin, LOW);
      delay(espacio);    
    }
    else{     
      digitalWrite(cwoutPin, HIGH);
      delay(raya); // (tiempo de la raya)
      digitalWrite(cwoutPin, LOW);
      delay(espacio);       
    }

    morse = morse >> 1; // shift right to see if Dit or Dah

    if(morse == 1){ // if the value is 1 then end of CW character
      delay(200);
      return;
    }
  }
 } // End of SENDCW routine
// -------------------------------


// -------------------------------
// ********************************
// **Rutina de envio de la baliza**
// ********************************



void txon()
{
  digitalWrite(ptt, HIGH);  //Activa la salida PTT y espera TXdelay msg antes de enviar CW
  delay(TXdelay);

digitalWrite(cwoutPin, HIGH);
}



void txoff()
{
  digitalWrite(cwoutPin, LOW);
  digitalWrite(ptt,LOW);
}



void baliza()
{
  // Morse Code repeating sequence main loop

  // ***********************
  // Send Callsign
  // ***********************

  digitalWrite(ptt, HIGH);  //Activa la salida PTT y espera TXdelay msg antes de enviar CW
  delay(TXdelay);

    { 
    for(x=0;x<sizeof(callsign)-1;x++)sendcw(callsign[x]);

delay (pausa);

    for(x=0;x<sizeof(locator)-1;x++)sendcw(locator[x]);
    }
  digitalWrite(cwoutPin, LOW);
  digitalWrite(ptt, LOW);  // Desactiva el PTT
 
  delay(intervalo);  // Hace una pausa para completar la secuencia de tiempo de envio de CW ID hasta 30 segundos
 
}

//******************************************
//***** Interrupcion para TX contínua ******
//******************************************

void test()
{
  // poniendo el dpin 2 a masa se activa el ptt y se transmite portadora mientras se mantenga pulsado el boton
  digitalWrite(ptt, HIGH);
  digitalWrite(cwoutPin,HIGH);
}




